Attribute VB_Name = "CommonFunction"
'     ,    
Option Compare Binary
Option Explicit

Const mnErrDeviceUnavailable = 68 '  
Const mnErrDiskNotReady = 71 '   
Const mnErrDeviceIO = 57 '  /
Const mnErrDiskFull = 61 '  
Const mnErrBadFileName = 64 '   
Const mnErrBadFileNameOrNumber = 52 '     
Const mnErrPathDoesNotExist = 76 '  
Const mnErrBadFileMode = 54 '     
Const mnErrFileAlreadyOpen = 55 '   
Const mnErrInputPastEndOfFile = 62 '   

Public Const SC_MINIMIZE = &HF020&

Public Const SW_HIDE = 0
Public Const SW_SHOWNORMAL = 1
Public Const SW_NORMAL = 1
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_SHOWMAXIMIZED = 3
Public Const SW_MAXIMIZE = 3
Public Const SW_SHOWNOACTIVATE = 4
Public Const SW_SHOW = 5
Public Const SW_MINIMIZE = 6
Public Const SW_SHOWMINNOACTIVE = 7
Public Const SW_SHOWNA = 8
Public Const SW_RESTORE = 9
Public Const SW_SHOWDEFAULT = 10
Public Const SW_MAX = 10



Public Const NIM_ADD = 0
Public Const NIM_MODIFY = 1
Public Const NIM_DELETE = 2
Public Const NIF_MESSAGE = 1
Public Const NIF_ICON = 2
Public Const NIF_TIP = 4

Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_RBUTTONDBLCLK = &H206



Public Const WM_SYSCOMMAND = &H112
Public Const MF_STRING = &H0
Public Const SC_NEWMENU = 1
Public Const GWL_WNDPROC = -4

Public Const INI_COMMENT_DELIM = "\\"

Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Type IniRecord   '      -  ini-.
    Name As String      '  
    Value As String     '  
    Section As String   '  
    Comment As String   '  
    End Type


Dim IniFile() As IniRecord '  ini-
Dim IniSection() As String '    ini-



'Declare Sub MessageBeep Lib "user32" (ByVal intN As Integer)
Declare Function CharToOem Lib "user32" Alias "CharToOemA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
'Declare Function CharToOemBuff Lib "user32" Alias "CharToOemBuffA" (ByVal lpszSrc As String, ByVal lpszDst As String, ByVal cchDstLength As Long) As Long
Declare Function OemToChar Lib "user32" Alias "OemToCharA" (ByVal lpszSrc As String, ByVal lpszDst As String) As Long
Declare Function GetCommandLine Lib "kernel32" Alias "GetCommandLineA" () As String
Declare Function Shell_NotifyIconA Lib "SHELL32" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Integer
Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long
Declare Function IsCharAlphaNumeric Lib "user32" Alias "IsCharAlphaNumericA" (ByVal cChar As Byte) As Long
Declare Function IsCharLower Lib "user32" Alias "IsCharLowerA" (ByVal cChar As Byte) As Long
Declare Function IsCharUpper Lib "user32" Alias "IsCharUpperA" (ByVal cChar As Byte) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function ShowWindowAsync Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

'   tray
Public Function SetTrayIcon(Mode As Long, hwnd As Long, Icon As Long, tip As String) As Long
    Dim nidTemp As NOTIFYICONDATA
    nidTemp.cbSize = Len(nidTemp)
    nidTemp.hwnd = hwnd
    nidTemp.uID = 0&
    nidTemp.uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    nidTemp.uCallbackMessage = WM_LBUTTONDOWN
    nidTemp.hIcon = Icon
    nidTemp.szTip = tip & Chr$(0)
    SetTrayIcon = Shell_NotifyIconA(Mode, nidTemp)
End Function


Public Function ChangeNameToValue(SourceStr As String, Name As String, ValueName As String) As Boolean
'       SourceStr.
'    -  True  False
Dim Buffer As String
Dim PosStr As Variant
Dim LengthName As Long

    ChangeNameToValue = False
    Buffer = SourceStr
    PosStr = InStr(SourceStr, Name) '  
    If IsNull(PosStr) Then
        Exit Function
        End If
    
    If PosStr = 0 Then
        Exit Function
        End If
    LengthName = Len(Name) '     
    Buffer = Left(SourceStr, PosStr - 1) + ValueName + Mid(SourceStr, PosStr + Len(Name), Len(SourceStr))
    SourceStr = Buffer
    ChangeNameToValue = True
    End Function

   
Public Function IsActiveForm(Name As String) As Boolean
'     
Dim MyForm As Form
    
    IsActiveForm = False
    '    Forms.
    For Each MyForm In Forms
        '   .
         If MyForm.Name = Name Then
            IsActiveForm = True
            Exit Function
            End If
        Next MyForm
    End Function

Public Function LengthMonth(NumberMonth As Integer, NumberYear As String) As Integer
'    
Dim Buffer As Variant
    If (NumberMonth < 0) Or (CDbl(NumberYear) < 0) Then
        LengthMonth = -1
        Exit Function
        End If
    Select Case NumberMonth
        Case 1, 3, 5, 7, 8, 10, 12
            LengthMonth = 31
        Case 4, 6, 9, 11
            LengthMonth = 30
        Case 2
            Buffer = "01.02." & NumberYear ' 
            Buffer = DateAdd("D", 28, Buffer)
            If Month(Buffer) = 3 Then
                LengthMonth = 28
                Else
                LengthMonth = 29
                End If
        End Select
        
    End Function
    

Public Function NumberWeek(DateDay As Variant) As Integer
'        
 Dim CurrentYear As Variant
 Dim CurrentMonth As Variant
 Dim CurrentWeek As Variant
 Dim Buffer As Variant
 Dim FirstMonthDay As Variant
    If Not IsDate(DateDay) Then
        NumberWeek = -1
        Exit Function
        End If
        
    CurrentYear = Year(DateDay) '  
    CurrentMonth = Month(DateDay) '   
    Buffer = "01.01." & CurrentYear
    '     
    CurrentWeek = DateDiff("ww", Buffer, DateDay, vbMonday, vbFirstJan1)
    FirstMonthDay = "01." & CurrentMonth & "." & CurrentYear
    '         
    Buffer = DateDiff("ww", Buffer, FirstMonthDay, vbMonday, vbFirstJan1)
    NumberWeek = CurrentWeek - Buffer + 1
    End Function

'   
Function AnsiToOem(strLine As String) As String '     
'   
   Dim strBuffer As String
   Dim res As Variant
   
   strBuffer = strLine '      
   res = CharToOem(strLine, strBuffer) '  ANSI   OEM
   AnsiToOem = strBuffer
   End Function
Function OemToAnsi(strLine As String) As String '     
'   
   Dim strBuffer As String
   Dim res As Variant
   
   strBuffer = strLine '      
   res = OemToChar(strLine, strBuffer) '  ANSI   OEM
   OemToAnsi = strBuffer
   End Function


Public Function AddStrToFile(strFileName As String, strLine As String, ErrCode As Integer) As Boolean
Dim iFile  As Integer

On Error GoTo Err_IOResult

    AddStrToFile = False

    If strFileName = "" Then Exit Function
        
    iFile = FreeFile()
    AddStrToFile = True
    Open strFileName For Append Shared As #iFile
    Print #iFile, strLine
    Close #iFile
    ErrCode = 0
    AddStrToFile = True
    Exit Function
    
Err_IOResult: '     
    ErrCode = Err.Number
    Err.Clear
End Function

'              
Public Function GetBaseExeName(strBaseName As String, strStartDir As String) As Boolean
Dim strTemp As String
Dim PosChr As Integer
Dim strLine As String
Dim strBuffer As String
    On Error Resume Next
    strBaseName = App.Path & "\" & App.EXEName & "."
    strStartDir = App.Path + "\"
    GetBaseExeName = True
    End Function


Function FileErrors() As Integer '      
    Dim intMsgType As Integer
    Dim strMsg As String
    Dim intResponse As Integer
    ' Return Value      Meaning
    ' 0                 Resume
    ' 1                 Resume Next
    ' 2                 Unrecoverable error
    ' 3                 Unrecognized error
    intMsgType = vbExclamation
    Select Case Err.Number
        Case mnErrDeviceUnavailable             ' Error 68
            strMsg = "That device appears unavailable."
            intMsgType = vbExclamation + vbOKCancel
        Case mnErrDiskNotReady                  ' Error 71
            strMsg = "Insert a disk in the drive and close the door."
            intMsgType = vbExclamation + vbOKCancel
        Case mnErrDeviceIO                      ' Error 57
            strMsg = "Internal disk error."
            intMsgType = vbExclamation + vbOKOnly
        Case mnErrDiskFull                      ' Error 61
            strMsg = "Disk is full. Continue?"
            intMsgType = vbExclamation + vbAbortRetryIgnore
        Case mnErrBadFileName, mnErrBadFileNameOrNumber ' Error 64 & 52
            strMsg = "That filename is illegal."
            intMsgType = vbExclamation + vbOKCancel
        Case mnErrPathDoesNotExist                ' Error 76
            strMsg = "That path doesn't exist."
            intMsgType = vbExclamation + vbOKCancel
        Case mnErrBadFileMode                     ' Error 54
            strMsg = "Can't open your file for that type of access."
        Case mnErrFileAlreadyOpen             ' Error 55
            strMsg = "This file is already open."
            intMsgType = vbExclamation + vbOKOnly
        Case mnErrInputPastEndOfFile              ' Error 62
            strMsg = "This file has a nonstandard end-of-file marker, "
            strMsg = strMsg & "or an attempt was made to read beyond "
            strMsg = strMsg & "the end-of-file marker."
            intMsgType = vbExclamation + vbAbortRetryIgnore
        Case Else
            FileErrors = 3
            Exit Function
    End Select
    intResponse = MsgBox(strMsg, intMsgType, "Disk Error")
    Select Case intResponse
        Case 1, 4       ' OK, Retry buttons.
            FileErrors = 0
        Case 2, 5       ' Cancel, Ignore buttons.
            FileErrors = 1
        Case 3          ' Abort button.
            FileErrors = 2
        Case Else
            FileErrors = 3
    End Select
End Function


'       bResult = True,    -  
' bResult=False     

Public Function GetFirstParam(strLine As String, strDelimiter As String, bResult As Boolean) As String
Dim iPosChr As Integer
    bResult = False
    iPosChr = InStr(strLine, strDelimiter)
    If iPosChr > 0 Then
        GetFirstParam = Left(strLine, iPosChr - 1)
        strLine = Right(strLine, Len(strLine) - iPosChr + 1 - Len(strDelimiter))
        bResult = True
        Else
        GetFirstParam = strLine
        End If 'If PosChr > 0
    
    End Function




Public Function ReadIniFile(strFileIniName As String) As Boolean
Dim strTemp As String
Dim strBuff As String
Dim IniVar As IniRecord
Dim strSection As String
Dim strComment As String
Dim iCount As Integer
Dim bResult As Boolean
Dim iFile As Integer
'On Error GoTo Err_ReadIniFile

    ReadIniFile = False
    strSection = ""
    iFile = FreeFile()
    Open strFileIniName For Input Shared As #iFile
    ReDim IniFile(0) '   
        
    Do While Not EOF(iFile)
        Input #iFile, strTemp '    INI 
        strBuff = strTemp
        strTemp = UCase(LTrim(strTemp)) '       
        
        ' 
        If Len(strTemp) = 0 Then GoTo NextStep '   
        If Left(strTemp, 1) = ";" Then GoTo NextStep '      ;
        If InStr(strTemp, "REM ") > 0 Then GoTo NextStep '     REM
        
        If (Left(strTemp, 1) = "[") And (InStr(strTemp, "]") > 0) Then '      [
            strSection = Trim(Mid(strTemp, 2, InStr(strTemp, "]") - 2))
        End If 'If (Left(strTemp, 1) = "[") And (InStr(strTemp, "]") > 0)
        
        If Left(strTemp, 1) = "=" Then GoTo NextStep '      =
        If InStr(strTemp, "=") = 0 Then GoTo NextStep '   = (  )
        strComment = GetIndexParam(strBuff, 2, INI_COMMENT_DELIM) '  
        strTemp = GetIndexParam(strTemp, 1, INI_COMMENT_DELIM)
               
        IniVar.Name = Trim(Left(strTemp, InStr(strTemp, "=") - 1)) '      
        strBuff = Left(strBuff, Len(strTemp))
        IniVar.Value = Trim(Right(strBuff, Len(strTemp) - InStr(strTemp, "="))) '   -  ...
        ReDim Preserve IniFile(UBound(IniFile) + 1)
        IniFile(UBound(IniFile)).Name = IniVar.Name
        IniFile(UBound(IniFile)).Value = IniVar.Value
        IniFile(UBound(IniFile)).Section = strSection
        IniFile(UBound(IniFile)).Comment = strComment
        
NextStep: '  ,     
        Loop
    
    Close #iFile '   
    ReadIniFile = True
    
    Exit Function '  
    '  

Err_ReadIniFile: '     
    'strBuff = "     " & Chr(13) & Chr(10) & strFileIniName & Chr(32) & Err.Number
    'MsgBox strBuff, vbOKOnly, " !"
    Err.Clear
    ReDim IniFile(0) '  
    

End Function


Public Function GetIniParam(Section As String, Name As String, Value As String) As Boolean
Dim iCount As Integer
On Error GoTo Err_GetIniParam
    GetIniParam = False '    ,    
    If UBound(IniFile) = 0 Then Exit Function
    For iCount = 1 To UBound(IniFile)
        If (IniFile(iCount).Section = UCase(Section)) And _
            (IniFile(iCount).Name = UCase(Name)) Then
            Value = IniFile(iCount).Value
            GetIniParam = True
            Exit Function
            End If
        Next iCount
    Exit Function
Err_GetIniParam:
    Err.Clear
    
End Function
Public Function SetIniParam(strSection As String, strName As String, strValue As String, strComment As String) As Boolean
Dim iCount As Integer
On Error GoTo Err_GetIniParam
    SetIniParam = False '    ,    
    If UBound(IniFile) = 0 Then Exit Function
    For iCount = 1 To UBound(IniFile)
        If (IniFile(iCount).Section = UCase(strSection)) And _
            (IniFile(iCount).Name = UCase(strName)) Then
            IniFile(iCount).Value = strValue
            SetIniParam = True
            Exit Function
            End If
        Next iCount
     '    - 
    ReDim Preserve IniFile(UBound(IniFile) + 1)
    IniFile(UBound(IniFile)).Name = strName
    IniFile(UBound(IniFile)).Value = strValue
    IniFile(UBound(IniFile)).Section = strSection
    IniFile(UBound(IniFile)).Comment = AnsiToOem(strComment)
    SetIniParam = True
      
    Exit Function
Err_GetIniParam:
    Err.Clear
    
End Function

'  ini-   
Public Function SaveIniFile(strFileIniName As String) As Boolean
Dim iSection As Integer
Dim iParam As Integer
Dim iFile As Integer
Dim strSectionCurr As String
Dim arrUsedSection()
Dim strBuff As String
Dim bRes As Boolean

On Error GoTo Err_SaveIniFile
    
    SaveIniFile = False
    iFile = FreeFile()
    ReDim arrUsedSection(0)
    Open strFileIniName For Output Shared As #iFile
    '  
    strSectionCurr = ""
    For iSection = 1 To UBound(IniFile)
        If strSectionCurr <> IniFile(iSection).Section Then '   
            bRes = False
            If UBound(arrUsedSection) > 0 Then
                For iParam = 1 To UBound(arrUsedSection) '      
                    strBuff = arrUsedSection(iParam)
                    If strBuff = IniFile(iSection).Section Then
                        bRes = True
                        iParam = UBound(arrUsedSection)
                    End If 'If strBuff = IniFile(iSection).Section Then
                Next iParam 'For iParam = 1 To UBound(arrUsedSection)
            End If 'If UBound(arrUsedSection) > 0 Then
            If bRes Then GoTo NextStep '     
            Print #iFile, "" '    
            strSectionCurr = IniFile(iSection).Section
            ReDim Preserve arrUsedSection(UBound(arrUsedSection) + 1)
            arrUsedSection(UBound(arrUsedSection)) = strSectionCurr '  ,   
            Print #iFile, "[" & strSectionCurr & "]"
            For iParam = 1 To UBound(IniFile)
                If strSectionCurr = IniFile(iParam).Section Then
                strBuff = IniFile(iParam).Name & "=" & IniFile(iParam).Value
                If Len(IniFile(iParam).Comment) > 0 Then strBuff = strBuff & " " & INI_COMMENT_DELIM & IniFile(iParam).Comment
                Print #iFile, strBuff
                End If 'If strSectionCurr = IniFile(iParam).Section Then
            Next iParam 'For iParam = 1 To UBound(IniFile)
        End If 'strSectionCurr <> IniFile(iSection).Section Then '   
NextStep:
    Next iSection 'For iSection = 1 To UBound(IniFile)
        
    Close #iFile
    ReDim arrUsedSection(0)
    SaveIniFile = True
    Exit Function
Err_SaveIniFile:
    Err.Clear
    ReDim arrUsedSection(0)
End Function

'    iIndex   strParam   iDelimiter
Public Function GetIndexParam(strParam As String, iIndex As Integer, strDelimiter As String) As String
Dim strBuff As String ' ,    strParam (    ,  )
Dim iCount As Integer
Dim iPos As Integer '    
Dim iPosOld As Integer '    
Dim iSize As Integer
Dim iDelim As Integer

    GetIndexParam = ""
    If iIndex < 1 Then Exit Function
    iSize = Len(strParam)
    iDelim = Len(strDelimiter)
    If (iSize <= iDelim) Or (iSize = 0) Or (iDelim = 0) Or (iIndex = 0) Then Exit Function
    strBuff = strParam
    '  ,   
 
    If Right(strBuff, Len(strDelimiter)) <> strDelimiter Then strBuff = strBuff & strDelimiter
    
    iSize = Len(strParam)
    iPos = 1
    iPosOld = 1
   
    For iCount = 1 To iIndex
        If (iPosOld > iSize) Then Exit Function
        iPos = InStr(iPos, strBuff, strDelimiter)
        If IsNull(iPos) Or (iPos = 0) Then Exit Function '    
        If (iCount = iIndex) Then Exit For
        iPosOld = iPos + iDelim '   
        iPos = iPos + 1
        Next iCount
   '     -  
   GetIndexParam = Mid(strBuff, iPosOld, iPos - iPosOld)
End Function


'     strToken  strLine
Public Function CountStr(strLine As String, strToken As String) As Integer
Dim iPos As Integer
Dim iCount As Integer
    iCount = 0
    iPos = 0
    Do
       iPos = InStr(iPos + 1, strLine, strToken)
       If iPos > 0 Then
        iCount = iCount + 1
        Else
        Exit Do
        End If 'If iPos > 0
      Loop While True
    CountStr = iCount
End Function
'  True,      - 
Public Function IsAlpha(strChar As String) As Boolean
Dim iIndex As Integer

    IsAlpha = False
    If Len(strChar) = 0 Then Exit Function
    For iIndex = 1 To Len(strChar)
        Select Case Asc(Mid(strChar, iIndex, 1))
            Case 0 To 64, 91 To 96, 123 To 191
                Exit Function
            End Select
        Next iIndex
    IsAlpha = True
End Function

' //        .
'// -  }

Public Function GetByte(lValue As Long, lPos As Byte) As Long
Dim iMask As Long
Dim iCount As Byte

    iMask = 1
    
    For iCount = 1 To lPos
        iMask = iMask * 2
    Next iCount
    If ((lValue And iMask) <> 0) Then
        GetByte = 1
    Else
        GetByte = 0
    End If

    
'    
End Function ' Public Function GetByte(lValue As Long, lPos As Byte) As Long



